package com.ruoyi.hezhi.mapper;

import com.github.pagehelper.PageInfo;
import com.ruoyi.hezhi.domain.TbCourse;
import com.ruoyi.hezhi.domain.TbSubjectWarehouseClass;
import com.ruoyi.hezhi.domain.vo.CourseListVO;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

/**
 * 课程Mapper接口
 *
 * @author ruoyi
 * @date 2024-09-14
 */
public interface TbCourseMapper
{
    /**
     * 查询课程
     *
     * @param courseId 课程主键
     * @return 课程
     */
    public TbCourse selectTbCourseByCourseId(Long courseId);

    /**
     * 查询课程列表
     *
     * @param tbCourse 课程
     * @return 课程集合
     */
    public List<TbCourse> selectTbCourseList(TbCourse tbCourse);
    /**
     * 查询课程列表
     *
     * @param courseName 课程
     * @return 课程集合
     */
    public TbCourse selectTbCourseByName(String courseName);

    /**
     * 查询课程列表
     *
     * @return 课程集合
     */
    public List<TbCourse> getAllCourseList();

    /**
     * 新增课程
     *
     * @param tbCourse 课程
     * @return 结果
     */
    public int insertTbCourse(TbCourse tbCourse);

    /**
     * 修改课程
     *
     * @param tbCourse 课程
     * @return 结果
     */
    public int updateTbCourse(TbCourse tbCourse);

    /**
     * 删除课程
     *
     * @param courseId 课程主键
     * @return 结果
     */
    public int deleteTbCourseByCourseId(Long courseId);

    /**
     * 批量删除课程
     *
     * @param courseIds 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteTbCourseByCourseIds(Long[] courseIds);

    /**
     * 查询课程列表
     *
     * @param params 参数
     * @return ok
     */
    public List<Map<String, Object>> getCourseList(Map<String, Object> params);

    /**
     * 查询课程详情
     *
     * @param params 参数
     * @return ok
     */
    public Map<String, Object> getCourseInfo(Map<String, Object> params);

    /**
     * 浏览量+1
     *
     * @param courseId 课程主键
     * @return 结果
     */
    public int addViewsNum(Long courseId);

    /**
     * 根据机构id查询课程列表
     *
     * @param evaluateAgencyId 机构名称
     * @return List<CourseListVO>
     */
    List<CourseListVO> getCourseListByEvaluateAgency(@Param("evaluateAgencyId") Long evaluateAgencyId);

    public List<Map<String, Object>> getCourseNameListForInput(@Param("searchValue") String searchValue);

    TbCourse selectTbCourseByNameAndEva(@Param("courseName") String courseName,@Param("evaluateAgencyId") Long evaluateAgencyId);
}
